<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use Carbon\Carbon;
use App\Http\Providers\iam\core\model\OracleOCIConnector;

class StgpelniscmmotintModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "stg_pelni_scm_mot_int";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "stgpelniscmmotint";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "transaction_number",
        "organization_id",
        "transaction_date",
        "subinventory_code",
        "transfer_subinventory",
        "transfer_date",
        "source_code",
        "process_flag",
        "transaction_mode",
        "lock_flag",

        "inventory_item_id",
        "item_segment1",
        "transaction_quantity",
        "transaction_uom",
        "attribute2",
        "attribute14",
        "transaction_source_type_id",
        "transaction_action_id",
        "transaction_type_id",
        "flagsync",
        "voyage_call",
        "total_line"


    ];

    public static function prepareSaveToOracle()
    {
        $start = 0;
        $limit = 100;
        $nRepeat = 0;
        (new LogsyncoracleModel)->setLogSync("Transfer Sub-Inventori", Carbon::now()->toDateTimeString(), "", "start");
        do {
            $stagings = (new StgpelniscmmotintModel())->getQuery()
                ->whereNull("stgpelniscmmotint.flagsync")
                ->orWhere("stgpelniscmmotint.flagsync", "<", 1)
                ->offset($start)->limit($limit)->get();
            foreach ($stagings as $stag) {
                if ((new StgpelniscmmotintModel())->saveToOracle($stag)) {
                    $updateStg = self::find($stag->id);
                    $updateStg->flagsync = 1;
                    $updateStg->update();
                }
            }
            if (count($stagings) < $limit) {
                $repeat = false;
            } else {
                $repeat = true;
                $start += $limit;
            }
            if (count($stagings) > 0) {
                $nRepeat++;
            }
        } while ($repeat);
        if ($nRepeat > 0) {
            (new LogsyncoracleModel)->setLogSync("Transfer Sub-Inventori", Carbon::now()->toDateTimeString(), "", "success");
        }
    }


    public function saveToOracle($data)
    {
        $query = "INSERT INTO pelni_scm_mot_int (TRANSACTION_NUMBER,ORGANIZATION_ID,TRANSACTION_DATE,SUBINVENTORY_CODE,TRANSFER_SUBINVENTORY,
TRANSFER_DATE,SOURCE_CODE,PROCESS_FLAG,TRANSACTION_MODE,LOCK_FLAG,INVENTORY_ITEM_ID,ITEM_SEGMENT1,TRANSACTION_QUANTITY,TRANSACTION_UOM,
ATTRIBUTE2,TRANSACTION_SOURCE_TYPE_ID,TRANSACTION_ACTION_ID,TRANSACTION_TYPE_ID, VOYAGE_CALL, TOTAL_LINE, ATTRIBUTE14) 
VALUES (
'" . $data->transaction_number . "',
'" . $data->organization_id . "',
TO_DATE('" . Carbon::parse($data->transaction_date)->format("Y/m/d H:i:s") . "', 'yyyy/mm/dd hh24:mi:ss'),
'" . $data->subinventory_code . "','" . $data->transfer_subinventory . "',
TO_DATE('" . Carbon::parse($data->transfer_date)->format("Y/m/d H:i:s") . "', 'yyyy/mm/dd hh24:mi:ss'),
'" . $data->source_code . "','" . $data->process_flag . "',
'" . $data->transaction_mode . "','" . $data->lock_flag . "',
'" . $data->inventory_item_id . "','" . $data->item_segment1 . "',
'" . $data->transaction_quantity . "','" . $data->transaction_uom . "','" . $data->attribute2 . "',
'" . $data->transaction_source_type_id . "','" . $data->transaction_action_id . "','" . $data->transaction_type_id . "', '" . $data->voyage_call . "', '" . $data->total_line . "', '" . $data->attribute14 . "')";
        try {
            $oracleOCI = new OracleOCIConnector();
            $oracleOCI->getConnection()->insert($query)->execute();
            (new LogsyncoracleModel)->setLogSync("Transfer Sub-Inventori : ".$data->transaction_number." - ".$data->item_segment1." - ".$data->attribute2 , Carbon::now()->toDateTimeString(), "", "posted");
            $oracleOCI->closeConnection();
            return true;
        } catch (\Exception $e) {
            (new LogsyncoracleModel)->setLogSync("Transfer Sub-Inventori : ".$data->transaction_number." - ".$data->item_segment1." - ".$data->attribute2 , Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
            return false;
        }
    }
}